2018-10-17 07:59 CEST

View Issue Details Jump to Notes ]
IDProjectCategoryView StatusLast Update
0005412Talerbank (demonstrator)public2018-09-21 14:35
ReporterTorsten Grothoff 
Assigned ToMarcello Stanisci 
PrioritylowSeverityfeatureReproducibilityhave not tried
StatusresolvedResolutionfixed 
Product Version 
Target VersionFixed in Version 
Summary0005412: Negative Balance
DescriptionGet a negative balance
Steps To Reproducetransfer more money then you have to any bank account using donation thing;
TagsNo tags attached.
Attached Files

-Relationships Relation Graph ] Dependency Graph ]
+Relationships

-Notes

~0013163

Marcello Stanisci (manager)

After you transfer 'more money than you have', the balance turns negative, and we did want this feature.

~0013165

Torsten Grothoff (updater)

Still open send the account 1 a large amount of kudos and it will work as long as it is not an intiger overflow

~0013166

Marcello Stanisci (manager)

Okay; but if the problem is a integer overflow, then it is something _different_ and so it should be filed in a dedicated bug. Thanks for reporting though.

~0013167

Christian Grothoff (manager)

Ok, I checked with Torsten, and the issue does not actually seem to be an Integer overflow (in test) [anymore]. Torsten's issue is that the balance can go _very_ deep into the negative, and while I agree with Marcello that we should support negative balances (after all, real bank accounts can go into the red), we also did mention having a "credit limit", i.e. a maximum amount by which one can go into the red.

I _thought_ we had a (credit) limit on withdraw, but just now tested it (on demo) and could go up to -120 KUDOS balance.

So let's re-interpret this bug as a feature request that accounts (other than the exchange) should have an _effective_ credit limit (say -20 KUDOS) that ought to be enforced for exchange withdraw and wire transfer dialogs.

This will be useful to test error handling for failed exchange withdraws due to 'bank refused' (in which case the wallet should simply not get the final notification from the bank and thus then never start to withdraw from the reserve; the interesting logic here is more that the wallet should eventually discard the reserve private key that was never put into action as the reserve was never filled).

~0013168

Marcello Stanisci (manager)

Fine. The bank logic does enforce negative limits, I'm pretty sure that the configuration is responsible now. IIRC, there is a "max_debt" option that lets
you decide what is the debt threshold allowed for any user, and if it's set as "zero" it goes limit-less.

~0013172

Christian Grothoff (manager)

Ok, then we should just set that limit to 20, to make it "real" ;-)

~0013252

Marcello Stanisci (manager)

91e69fe77baa2abba30 gives -20 debit for all bank _customers_.
+Notes

-Issue History
Date Modified Username Field Change
2018-07-28 17:14 Torsten Grothoff New Issue
2018-07-28 17:14 Torsten Grothoff Status new => assigned
2018-07-28 17:14 Torsten Grothoff Assigned To => Marcello Stanisci
2018-07-29 10:05 Marcello Stanisci Note Added: 0013163
2018-07-29 10:05 Marcello Stanisci Status assigned => resolved
2018-07-29 10:05 Marcello Stanisci Resolution open => no change required
2018-08-01 21:25 Torsten Grothoff Status resolved => feedback
2018-08-01 21:25 Torsten Grothoff Resolution no change required => reopened
2018-08-01 21:25 Torsten Grothoff Note Added: 0013165
2018-08-01 21:51 Marcello Stanisci Note Added: 0013166
2018-08-02 08:57 Christian Grothoff Note Added: 0013167
2018-08-02 08:57 Christian Grothoff Priority normal => low
2018-08-02 08:57 Christian Grothoff Severity minor => feature
2018-08-02 08:57 Christian Grothoff Status feedback => assigned
2018-08-02 10:26 Marcello Stanisci Note Added: 0013168
2018-08-02 10:37 Christian Grothoff Note Added: 0013172
2018-09-21 14:35 Marcello Stanisci Status assigned => resolved
2018-09-21 14:35 Marcello Stanisci Resolution reopened => fixed
2018-09-21 14:35 Marcello Stanisci Note Added: 0013252
+Issue History